/* $Workfile: OsaLinuxDef.h $   $Revision: 6 $    $Modtime: 6/12/08 3:34p $  */
#ifndef OSA_LINUX_DEF_H
#define OSA_LINUX_DEF_H
/*******************************************************************************

  @doc PublicHwApi OsaLinuxDef

  Copyright (C) 1999 - 2008 Odin TeleSystems Inc., All Rights Reserved

  OTX Generic Hardware Driver API

  @module
  OsaLinuxDef | This file contains types and macros for the Linux
  version of the platform generic Osa implementation 
  (used by the demo programs)

  @contents2
  OsaLinuxDef.h |

  @index func | OsaLinuxDef

  @contents2
  Linux Osa Types and Macros | Types and macros for the Linux
  version of the platform generic Osa implementation 
  (used by the demo programs)

*******************************************************************************/
#if !OSA_LINUX
#error "This file should only be included in OSA_LINUX configurations"
#endif


#define OSA_CDECL

#ifdef __cplusplus
extern "C" {
#endif

#ifdef __cplusplus
#ifdef __KERNEL__
#define NULL 0
#endif
#endif

  // All Linux configurations use the same types
// But we need the correct system header for it
// Different Linux configurations are compiled using different INCLUDE paths
// It's not nice to include another header (especialy not a systeim header) in
// one of our 'def' files, but that's the easiest way to get architecture
// independence under Linux.
#ifdef __KERNEL__
#include <linux/autoconf.h>
#include <linux/types.h>
#else
#include <asm/types.h>
#include <stddef.h>
#endif

#ifdef __cplusplus
}
#endif

typedef __u64   OsaUint64;
typedef __u32   OsaUint32;
typedef __u16   OsaUint16;
typedef __u8    OsaUint8;
typedef __s64   OsaInt64;
typedef __s32   OsaInt32;
typedef __s16   OsaInt16;
typedef __s8    OsaInt8;
typedef double  OsaFp64;
typedef void    OsaVoid, *OsaVoidP;
typedef void    *OsaPMDL;
typedef unsigned long OsaWchar, *OsaWcharP;


/*******************************************************************************

  Copyright (C) Odin TeleSystems Inc., 1999 - 2008

  All rights reserved. No part of this computer program may be reproduced,
  stored in any retrieval system, or transmitted, in any form or by any
  means, electronic, mechanical, photocopying, recording, or otherwise,
  without the prior written permission of Odin TeleSystems Inc., or without
  a permission stipulated in the agreement/contract under which this computer
  program was supplied.

*******************************************************************************/
#endif // OSA_LINUX_DEF_H
